"""Raw representations of every data type in the AWS CodeStar service.

See Also:
    `AWS developer guide for CodeStar
    <https://docs.aws.amazon.com/codestar/latest/userguide/welcome.html>`_

This file is automatically generated, and should not be directly edited.
"""

from attr import attrib
from attr import attrs

from ..core import ATTRSCONFIG
from ..core import Resource
from ..core import ResourceProperties
from ..core import create_object_converter

__all__ = ["GitHubRepository", "GitHubRepositoryProperties"]


@attrs(**ATTRSCONFIG)
class GitHubRepositoryProperties(ResourceProperties):
    Code = attrib(default=None)
    EnableIssues = attrib(default=None)
    IsPrivate = attrib(default=None)
    RepositoryAccessToken = attrib(default=None)
    RepositoryDescription = attrib(default=None)
    RepositoryName = attrib(default=None)
    RepositoryOwner = attrib(default=None)


@attrs(**ATTRSCONFIG)
class GitHubRepository(Resource):
    """A Git Hub Repository for CodeStar.

    See Also:
        `AWS Cloud Formation documentation for GitHubRepository
        <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-codestar-githubrepository.html>`_
    """

    RESOURCE_TYPE = "AWS::CodeStar::GitHubRepository"

    Properties: GitHubRepositoryProperties = attrib(
        factory=GitHubRepositoryProperties,
        converter=create_object_converter(GitHubRepositoryProperties),
    )
